    WIN_WIDTH		equ 300
    HEADER_HEIGHT	equ 38
    HEADER_PADDING_LEFT equ 8
    MARGIN		equ 6
    LIST_LINE_HEIGHT	equ 19
    LIST_LINES_MAX	equ 17
    COLOR_BACKGROUND	equ 0x202020
    COLOR_FRAME 	equ 0x111111
    COLOR_TEXT		equ 0xF0F0F0
    COLOR_TEXT_FILE	equ 0xF0F0F0
    COLOR_TEXT_BIND	equ 0xA0F0F0
    COLOR_TEXT_DIR	equ 0xF0F0A0
    MASK_SELECT 	equ +0x102020
    MASK_INFO		equ -0x505050

    HEADER_WIDTH	equ WIN_WIDTH
    FONT_WIDTH		equ 6
    FONT_HEIGHT 	equ 9
    LABEL_MARGIN	equ 6
    LABEL_HEIGHT	equ (FONT_HEIGHT * 2 + LABEL_MARGIN)
    LABEL_ADDRES_TOP	equ (HEADER_HEIGHT / 2 - LABEL_HEIGHT / 2)
    LABEL_SEARCH_TOP	equ (LABEL_ADDRES_TOP + FONT_HEIGHT + LABEL_MARGIN)
    EDITBOX_HEIGHT	equ 16
    EDITBOX_TOP 	equ (LABEL_SEARCH_TOP + (EDITBOX_HEIGHT - LABEL_HEIGHT) / 2)
    EDITBOX_LEFT	equ (HEADER_PADDING_LEFT + label_search.length * FONT_WIDTH)
    EDITBOX_WIDTH	equ (HEADER_WIDTH - EDITBOX_LEFT - HEADER_PADDING_LEFT)
    LIST_WIDTH		equ (WIN_WIDTH - MARGIN * 2)
    LIST_LEFT		equ MARGIN
    LIST_PADDING_TOP	equ (LIST_LINE_HEIGHT / 2 - FONT_HEIGHT / 2)
    ITEMS_COUNT 	equ 256

    use32
    org     0
    db	    'MENUET01'
    dd	    1, main, dataend, memory, stacktop, 0, 0

    include "../../proc32.inc"
    include "../../macros.inc"
    include "../../dll.inc"
    include "../../develop/libraries/box_lib/trunk/box_lib.mac"
;   include "../../debug.inc"

    include "string.inc"
    include "macros.inc"

 ;===============================

    label_search db "Search:", 0
     .length = $ - label_search
    dots db ". . .", 0
    file_assoc db "/sys/file managers/eolite.ini", 0
     .sec db "Assoc", 0
    file_cfg db "/sys/settings/"
     .name db "eagle.ini", 0
     .sec_binds db "Binds", 0
     .sec_cfg db "Config", 0
     .key_only_exec db "only_exec", 0
    text_editor db "/sys/tinypad", 0
    start_dir db "/sys"
    slash_str db "/", 0

    edb_search edit_box \
	EDITBOX_WIDTH, EDITBOX_LEFT, EDITBOX_TOP, \  ;; width, left, top
	COLOR_FRAME, COLOR_FRAME, COLOR_FRAME, \     ;; background, shift, focus border
	COLOR_FRAME, COLOR_TEXT, \		     ;; blur border, text
	255, search_str, 0, \			     ;; max, text, group
	ed_always_focus + ed_focus, 0, 0	     ;; flags, size, pos

    is_read:
	dd  1, 0, 0, ITEMS_COUNT, files_list
	db  0
	dd  cur_dir
    is_execute:
	dd  7, 0, 0, 0, 0
	db  0
	dd  fullpath
    is_openas:
	dd  7, 0, fullpath, 0, 0
	db  0
	dd  buffer
    is_folder:
	dd  7, 0, fullpath, 0, 0
	db  "/sys/file managers/eolite", 0

 imports:
    library libini, "libini.obj",\
	    boxlib, "box_lib.obj"
    import  libini, libini.get_str, "ini_get_str", \
		    libini.get_num, "ini_get_int", \
		    libini.enum_keys, "ini_enum_keys"
    import  boxlib, editbox.draw, "edit_box", \
		    editbox.key, "edit_box_key"

 ;===============================

 main:
    mov     [search_dup], byte '*'
    stdcall string.copy, start_dir, cur_dir

    mcall   68, 11
    stdcall dll.Load, imports

 ;; ᪠ ᮡ⨩
    mcall   40, 11b

 ;; ᢮⢠ 
    mcall   9, buffer, -1
    mov     ecx, eax
    mov     edx, dword [buffer + 30]
    mov     [win_pid], edx

 ;; , ᫨ 㦥  ⠪ 
    mov     esi, 0
  @@:
    mcall   9, buffer
    stdcall string.to_lower_case, buffer + 10
    cmpe    edx, dword [buffer + 30], .next
    cmpne   dword [buffer + 10], dword "@eag", .next
 .kill:
    mcall   18, 2
    mov     esi, 1
 .next:
    dec     ecx
    cmpne   ecx, 0, @b

    cmpne   esi, 0, exit

 ;;  
    mcall   14
    shr     eax, 16 + 1 ;; width/2
    sub     eax, WIN_WIDTH / 2
    mov     [win_x], eax

 ;; ⥭ 䨣
    invoke  libini.get_num, file_cfg, file_cfg.sec_cfg, file_cfg.key_only_exec, 0
    mov     [only_exec], eax

    stdcall read_folder
    stdcall build_list

 ;----------------------

 update:
    mcall   23, 5
    cmpe    eax, EV_REDRAW, event_redraw
    cmpe    eax, EV_KEY, event_key

    mcall   18, 7
    mov     ecx, eax
    mcall   9, buffer
    mov     eax, dword[buffer + 30]
    cmpne   [win_pid], eax, exit

    jmp     update

 ;----------------------

 event_redraw:
    mcall   12, 1

 ;; window
    mov     ecx, [win_height]
    mcall   0, <[win_x], WIN_WIDTH - 1>, , 0x51 shl 24
    mcall   8, <0, WIN_WIDTH>, , 1b shl 30 + 1b shl 29

 ;; header
    mcall   13, , HEADER_HEIGHT, COLOR_FRAME

 ;; corners
    mov     eax, 13
    mov     ebx, 1 shl 16 + (MARGIN - 1)
    mov     ecx, HEADER_HEIGHT shl 16 + 1
    mov     edx, 0
  @@:
    mcall
    add     ebx, 1 shl 16
    add     ecx, 1 shl 16
    dec     bx
    jnz     @b

    mov     ebx, (WIN_WIDTH - MARGIN) shl 16 + MARGIN - 1
    mov     ecx, HEADER_HEIGHT shl 16 + 1
  @@:
    mcall
    add     ecx, 1 shl 16
    dec     bx
    jnz     @b

 ;; labels
    mcall   4, <HEADER_PADDING_LEFT, LABEL_SEARCH_TOP>, 0x80 shl 24 + COLOR_TEXT, label_search

    mov     bx, LABEL_ADDRES_TOP
    mov     ecx, 0x80 shl 24 + COLOR_TEXT + MASK_INFO
    mcall   , , , cur_dir

 ;; editbox
    invoke  editbox.draw, edb_search

 ;; list
    call    draw_list

    jmp     update

 ;----------------------

 event_key:
    mcall   2
    cmpe    ah,  27, exit
    cmpe    ah,  13, .on_enter
    cmpe    ah, 179, .on_arr_right
    cmpe    ah, 176, .on_arr_left
    cmpe    ah, 178, .on_arr_up
    cmpe    ah, 177, .on_arr_down

 ;;   ⥪
 .on_editbox:
    invoke  editbox.key, edb_search
    stdcall build_list
    mov     esi, [win_height]
    mcall   67, -1, -1, -1
    stdcall draw_list

    jmp     update

 ;;  "up"
 .on_arr_up:
    cmpe    [list.size], 0, update
    cmpe    [search_str], byte ':', .binds1
    cmpe    [search_str], byte '/', .dirs1
  .files1:
    mov     edx, 0
    jmp     @f
  .binds1:
    mov     edx, 1
    jmp     @f
  .dirs1:
    mov     edx, 2
  @@:
    stdcall draw_line, [list.index], edx, 0

    cmpl    [list.index], 1, .to_end
 .to_up:
    dec     [list.index]
    jmp     @f
 .to_end:
    mov     eax, [list.size]
    dec     eax
    mov     [list.index], eax
  @@:
    stdcall draw_line, [list.index], edx, 1
    jmp     update

 ;;  "down"
 .on_arr_down:
    cmpe    [list.size], 0, update
    cmpe    [search_str], byte ':', .binds2
    cmpe    [search_str], byte '/', .dirs2
  .files2:
    mov     edx, 0
    jmp     @f
  .binds2:
    mov     edx, 1
    jmp     @f
  .dirs2:
    mov     edx, 2
  @@:
    stdcall draw_line, [list.index], edx, 0

    mov     eax, [list.size]
    dec     eax
    cmpge   [list.index], eax, .to_begin
 .to_down:
    inc     [list.index]
    jmp     @f
 .to_begin:
    mov     [list.index], dword 0
 @@:
    stdcall draw_line, [list.index], edx, 1
    jmp     update

 ;;  "right"
 .on_arr_right:
    mov     esi, [list.index]
    shl     esi, 8
    mov     ebx, 0

  ;; if bind
    cmpne   [search_str], byte ':', @f
    add     esi, list.binds_v
    stdcall string.length, esi
    add     eax, esi
    cmpne   [eax - 1], byte '/', update
    mov     ebx, 1
  @@:

  ;; if dir
    cmpne   [search_str], byte '/', @f
    add     esi, list.dirs
    mov     ebx, 1
  @@:

  ;; else exit
    cmpe    ebx, 0, update

  ;; if it is full path
    cmpne   [esi], byte '/', @f
    mov     [cur_dir], byte 0
  @@:

  ;; go to
    stdcall string.concatenate, esi, cur_dir

  ;; check last slash
    stdcall string.length, cur_dir
    add     eax, cur_dir
    cmpe    [eax - 1], byte '/', @f
    stdcall string.concatenate, slash_str, cur_dir
  @@:

    jmp     .update_list

 ;;  "left"
 .on_arr_left:
    stdcall string.last_index_of, cur_dir, '/', 2
    cmpe    eax, -1, update

    add     eax, cur_dir
    mov     [eax], byte 0

 ;; ᫥ left  right
 .update_list:
    mov     [search_str], byte 0
    mov     [edb_search.size], 0
    mov     [edb_search.pos], 0

    stdcall read_folder
    stdcall build_list
    mov     esi, [win_height]
    mcall   67, -1, -1, -1
    jmp     event_redraw

 ;;  "enter"
 .on_enter:
    mov     ebx, [list.index]
    imul    ebx, 256
    cmpe    [search_str], byte ':', .binds
    cmpe    [search_str], byte '/', .dirs
 .files:
    add     ebx, list.files
    jmp     .next
 .binds:
    add     ebx, list.binds_v
    stdcall string.length, ebx
    add     eax, ebx
    cmpe    [eax - 1], byte '/', .open
    jmp     .next
 .dirs:
    add     ebx, list.dirs
 .open:
    cmpe    [ebx], byte '/', @f
    stdcall string.copy, cur_dir, fullpath
  @@:
    stdcall string.concatenate, ebx, fullpath
    mcall   70, is_folder
    jmp     exit
 .next:

    stdcall string.last_index_of, ebx, '.', 1
    cmpe    eax, -1, .execute
    mov     esi, eax
    stdcall string.last_index_of, ebx, '/', 1
    cmpl    esi, eax, .execute
    mov     eax, esi

 .open_as:
    add     esi, ebx
    cmpe    [esi - 1], dword '.kex', .execute

    invoke  libini.get_str, file_assoc, file_assoc.sec, esi, buffer, 512, text_editor

    cmpe    [ebx], byte '/', @f
    stdcall string.copy, cur_dir, fullpath
  @@:
    stdcall string.concatenate, ebx, fullpath
    mcall   70, is_openas
    jmp     exit

 .execute:
    cmpe    [ebx], byte '/', @f
    stdcall string.copy, cur_dir, fullpath
  @@:
    stdcall string.concatenate, ebx, fullpath
    mcall   70, is_execute
    jmp     exit

 ;----------------------

 exit:
    mcall   -1

 ;--------------------------------------------

 proc read_folder
 ;; read binds
    mov     [binds_list.size], dword 0

  ;; read binds from current dir
    stdcall string.copy, cur_dir, fullpath
    stdcall string.concatenate, file_cfg.name, fullpath
    invoke  libini.enum_keys, fullpath, file_cfg.sec_binds, binds_callback
    mov     [fullpath], byte 0

  ;; read binds from root
    invoke  libini.enum_keys, file_cfg, file_cfg.sec_binds, binds_callback

 ;; read files & dirs
    mcall   70, is_read
    mov     [files_list.size], ebx

    ret
 endp

 ;--------------------------------------------

 proc build_list
    mov     edi, files_list + 32 + 40
    mov     ebx, [files_list.size]

    cmpe    [search_str], byte ':', .binds
    cmpe    [search_str], byte '/', .dirs
 .files:
    mov     eax, search_str
    mov     esi, list.files
    mov     ecx, list.files_s
    mov     dl, 0
    jmp     @f
 .binds:
    mov     eax, search_str + 1
    mov     esi, list.binds
    mov     edx, list.binds_v
    mov     ecx, list.binds_s

    mov     edi, binds_list
    mov     ebx, [binds_list.size]

    jmp     @f
 .dirs:
    mov     eax, search_str + 1
    mov     esi, list.dirs
    mov     ecx, list.dirs_s
    mov     dl, 1
  @@:
    mov     dword [ecx], 0
    stdcall string.copy, eax, search_dup + 1
    stdcall string.to_lower_case, search_dup

 ;; if binds must shown, get it
    cmpe    [search_str], byte ':', .binds_build

 .build:
 ;; is type == mode
    mov     eax, edi
    sub     eax, 40
    mov     eax, [eax]
    shr     eax, 4
    and     al, 1
    cmpne   al, dl, .next

 ;; hide ".*"
    cmpe    [edi], byte '.', .next

 ;; is *.*
    cmpe    dl, 1, @f
    cmpe    [only_exec], 0, @f
    stdcall string.last_index_of, edi, '.', 1
    cmpne   eax, -1, .next
  @@:

 ;; match filename
    stdcall string.to_lower_case, edi
    stdcall string.match, edi, search_dup
    cmpe    eax, 0, .next
    stdcall string.copy, edi, esi

 ;; inc
    inc     dword [ecx]
    cmpe    dword [ecx], (LIST_LINES_MAX + 1), .end
    add     esi, 256

 .next:
    add     edi, 304
    dec     ebx
    cmpne   ebx, 0, .build

 .end:
 ;; if more, that max
    mov     [list.more], 0
    mov     ebx, 0
    cmple   [ecx], dword LIST_LINES_MAX, @f
    sub     [ecx], dword 2
    inc     ebx
    mov     [list.more], 1
  @@:

    mov     ecx, [ecx]
    mov     [list.size], ecx

 ;; calc win_height
    mov     edx, ecx
    add     edx, ebx
    imul    edx, LIST_LINE_HEIGHT
    add     edx, HEADER_HEIGHT - 1
    mov     [win_height], edx

 ;; if index >= size
    cmpl    [list.index], ecx, @f
    dec     ecx
    mov     [list.index], ecx
  @@:

 ;; if index < 0
    cmpnl   [list.index], 0, @f
    mov     [list.index], 0
  @@:

    ret

 .binds_build:
 ;; match filename
    stdcall string.to_lower_case, edi
    stdcall string.match, edi, search_dup
    cmpe    eax, 0, .binds_next

 ;; copy name and value of bind
    stdcall string.copy, edi, esi
    add     edi, 256 * ITEMS_COUNT
    stdcall string.copy, edi, edx
    sub     edi, 256 * ITEMS_COUNT

 ;; inc
    inc     dword [ecx]
    cmpe    dword [ecx], (LIST_LINES_MAX + 1), .binds_end
    add     esi, 256
    add     edx, 256

 .binds_next:
    add     edi, 256
    dec     ebx
    cmpne   ebx, 0, .binds_build

 .binds_end:
    jmp     .end
 endp

 ;--------------------------------------------

 proc draw_line uses esi edx ecx ebx eax, _index, _mode, _selected
    mov     esi, 0

 ;; if dots
    cmpne   [_index], -1, @f
    mov     eax, [list.size]
    mov     [_index], eax
    mov     esi, 1
  @@:

 ;; set bg color
    mov     edx, COLOR_BACKGROUND
    cmpne   [_selected], dword 1, @f
    add     edx, MASK_SELECT
  @@:

 ;; add gradient
    mov     ecx, 0x010101
    imul    ecx, [_index]
    sub     edx, ecx

 ;; get y
    mov     ecx, [_index]
    imul    ecx, LIST_LINE_HEIGHT
    shl     ecx, 16
    add     ecx, HEADER_HEIGHT shl 16 + LIST_LINE_HEIGHT

 ;; draw background
    mcall   13, <MARGIN, LIST_WIDTH>

 ;; get pos for text
    mov     ebx, [_index]
    imul    ebx, LIST_LINE_HEIGHT
    add     ebx, (10 + MARGIN) shl 16 + HEADER_HEIGHT + LIST_PADDING_TOP

 ;; get color and text
    cmpne   esi, 0, .dots
    mov     edx, [_index]
    shl     edx, 8
    cmpe    [_mode], 1, .binds
    cmpe    [_mode], 2, .dirs
 .files:
    mov     ecx, 0x80 shl 24 + COLOR_TEXT_FILE
    add     edx, list.files
    jmp     @f
 .binds:
    mov     ecx, 0x80 shl 24 + COLOR_TEXT_BIND
    add     edx, list.binds
    jmp     @f
 .dirs:
    mov     ecx, 0x80 shl 24 + COLOR_TEXT_DIR
    add     edx, list.dirs
    jmp     @f
 .dots:
    mov     edx, dots
    mov     ecx, 0x80 shl 24 + COLOR_TEXT + MASK_INFO
  @@:

    mcall   4

    ret
 endp

 ;--------------------------------------------

 proc draw_list
    cmpe    [search_str], byte ':', .binds
    cmpe    [search_str], byte '/', .dirs
 .files:
    mov     ebx, 0
    jmp     @f
 .binds:
    mov     ebx, 1
    jmp     @f
 .dirs:
    mov     ebx, 2
  @@:

    mov     ecx, [list.size]
  @@:
    dec     ecx
    cmpe    ecx, -1, @f

 ;; edx = selected
    mov     edx, 0
    cmpne   ecx, [list.index], .not_selected
    mov     edx, 1
 .not_selected:

    stdcall draw_line, ecx, ebx, edx
    jmp     @b
  @@:

    cmpe    [list.more], byte 0, @f
    stdcall draw_line, -1, 0, 0
  @@:

    ret
 endp

 ;--------------------------------------------

 proc binds_callback _f_name, _sec_name, _key_name, _value
    mov     edi, [binds_list.size]
    shl     edi, 8		; * 256
    mov     esi, edi
    add     edi, binds_list
    add     esi, binds_list.values

    stdcall string.to_lower_case, [_key_name]
    stdcall string.copy, [_key_name], edi
    stdcall string.copy, [_value], esi

    mov     eax, 0
    inc     [binds_list.size]
    cmpg    [binds_list.size], ITEMS_COUNT, @f
    mov     eax, 1
  @@:

    ret
 endp

 ;--------------------------------------------

 dataend:

 ;===============================

    rb	    2048
 stacktop:

 win_x	    rd 1
 win_height rd 1
 win_pid    rd 1
 only_exec  rd 1
 list:
  .files    rb 256 * (LIST_LINES_MAX + 1)
  .files_s  rd 1
  .binds    rb 256 * (LIST_LINES_MAX + 1)
  .binds_v  rd 256 * (LIST_LINES_MAX + 1)
  .binds_s  rd 1
  .dirs     rb 256 * (LIST_LINES_MAX + 1)
  .dirs_s   rd 1
  .index    rd 1
  .more     rb 1
  .size     rd 1
 group	    rd 1
 search_str rb 256
 search_dup rb 257
 files_list rb 32 + 304 * ITEMS_COUNT
  .size     rd 1
 binds_list rb 256 * ITEMS_COUNT
  .values   rb 256 * ITEMS_COUNT
  .size     rd 1
 buffer     rb 1024
 cur_dir    rb 1024
 fullpath   rb 2048

 memory: